#include "dictionary.h"

#include <algorithm>
#include <fstream>
#include <iostream>
#include <sstream>

using namespace std;

dictionary * dictionary::_instance = NULL;

dictionary::dictionary(){

}

dictionary::~dictionary(){

}

dictionary * dictionary::get_instance(){
    if (_instance==NULL){
        _instance = new dictionary();
    }
    return _instance;
}

void dictionary::destroy_instance(){
    if (_instance!=NULL){
        delete _instance;
    }
    _instance = NULL;
}

void dictionary::init (const char * filename){
    cout<<"Initializing dictionary from "<<string(filename)<<"..."<<"\n";
    ifstream fis (filename);
    string line, token;
    while (fis.good() && !fis.eof()){
        getline(fis, line);
        stringstream parser(line);
        while (parser>>token){
            _words.push_back(token);
        }
    }
    fis.close();
    sort(_words.begin(), _words.end());
    cout<<"Dictionary initialized..."<<"\n";
}

unsigned int dictionary::word_count (){
    return _words.size();
}

string * dictionary::get_word (unsigned int index){
    if (index<_words.size()){
        return &(_words[index]);
    } else {
        return NULL;
    }
}

pair<unsigned int, unsigned int> dictionary::get_interval (const string & range_min, const string & range_max){
    // The interval is closed on the lower-bound and open on the upper-bound...
    vector<string>::iterator low, high;
    low = lower_bound(_words.begin(), _words.end(), range_min);
    high = upper_bound(_words.begin(), _words.end(), range_max);
    return pair<unsigned int, unsigned int> (low-_words.begin(), high-_words.begin());
}


